<?php
class Plugin_Acl extends Zend_Controller_Plugin_Abstract
{
public function preDispatch(Zend_Controller_Request_Abstract $request)
{
$acl = new Zend_Acl();

$acl->addRole(new Zend_Acl_Role("none"));
$acl->addRole(new Zend_Acl_Role("guest"));
$acl->addRole(new Zend_Acl_Role("member"),"guest");
$acl->addRole(new Zend_Acl_Role("admin"),"member");

$acl->addResource(new Zend_Acl_Resource("article"));
$acl->addResource(new Zend_Acl_Resource("auth"));

$acl->deny('none',null);

$acl->allow('guest', 'article', 'index');
$acl->allow('member', 'article', array('add','edit'));
$acl->allow('admin', null);
$acl->allow(array('guest','member','admin'),'auth');
	
    $auth = Zend_Auth::getInstance();
    if ($auth->hasIdentity()) {
      $identity = $auth->getIdentity();
      //$role = $identity->role;
    } else {
    	$identity= 'none';
      $role = 'none';
    }
    $controller = $request->controller;
    $action = $request->action;
    if (!$acl->isAllowed($identity, $controller, $action)) {
      if ($identity == 'none') {
        $request->setControllerName('auth');
        $request->setActionName('login');
      } else {
        $request->setControllerName('error');
        $request->setActionName('accessdenied');
      }
    }
  }
}