<?php
class FormHelper
{
	public static function isadmincheckbox()
	{
		return "<img src='obrazek.jpg' />ISADMIN";
	}
}

class RequiredFieldValidator extends Zend_Validate_Abstract
{
    const ISEMPTY = 'isempty';
 
    protected $_messageTemplates = array(
        self::ISEMPTY => "Pole nie moze byc puste"
    );
 
    public function isValid($value)
    {
        $this->_setValue($value);
 
        if (!is_string($value) || !( strlen($value) > 0 ) ) {
            $this->_error(self::ISEMPTY);
            return false;
        }
 
        return true;
    }
}

class IndexController extends Zend_Controller_Action
{
	private function createElement($name,$desc,$type,$showLabel=TRUE)
	{
		$ctrl = null;
		if ( $type == "text" )
			$ctrl = new Zend_Form_Element_Text($name);	
		if ( $type == "password" )
			$ctrl = new Zend_Form_Element_Password($name);
		if ( $type == "submit" )
			$ctrl = new Zend_Form_Element_Submit($name);
		$ctrl->setLabel($desc);
    	$ctrl->setDecorators( array(
    			array('ViewHelper'),
    			//array('Label'),
    			array('Errors'),
    			array('HtmlTag', array('tag'=>'div', 'class' => 'formElement'))
    		));
    	if ( $showLabel )
    		$ctrl->addDecorator('Label');
    	return $ctrl;
	}
	
    public function init()
    {
        /* Initialize action controller here */
    }

    public function indexAction()
    {
    	$login = $this->createElement("login","Nazwa uzytkownika","text");
    	$haslo = $this->createElement("haslo","Haslo","password");
    	$powtorzHaslo = $this->createElement("powtorzHaslo","Powtorz haslo","password");
       	$dataUrodzenia = $this->createElement("dataUrodzenia", "Data urodzenia","text");
       	$email = $this->createElement("email", "E-Mail", "text");

		$isadmin = new Zend_Form_Element_Checkbox('isadmin');
		$isadmin->setDecorators( array(			
			array('ViewHelper'),
			array('CallBack',array(
				'callback' => array('FormHelper', 'isadmincheckbox')
				),
			array('HtmlTag', array('tag' => 'div', 'class' => 'filterelement'))
			))); 
       	
       	$submit = $this->createElement("zapisz","Zapisz","submit", FALSE);
       	
       	$login->setRequired(true);
       	$haslo->setRequired(true);
       	$powtorzHaslo->setRequired(true);
       	       	
       	$loginToShortValidator = new Zend_Validate_StringLength();
       	$loginToShortValidator->setMin(4);
       	$loginToShortValidator->setMessage("Login musi miec co najmniej 4 znaki",Zend_Validate_StringLength::TOO_SHORT );
       	
		$loginValidator = new Zend_Validate_Alnum();		
		$loginValidator->setMessage("Login musi byc alfanumeryczny", Zend_Validate_Alnum::NOT_ALNUM );
		$login->addValidators( array( $loginValidator, $loginToShortValidator ) );
		
		$hasloValidator = new Zend_Validate_StringLength();
       	$hasloValidator->setMin(6);
       	$hasloValidator->setMessage("Haslo musi miec co najmniej 6 znakow",Zend_Validate_StringLength::TOO_SHORT );
       	$haslo->addValidator($hasloValidator);
       	
       	$powtorzHasloValidator = new Zend_Validate_Callback(
       		function($value,$options)
       		{
       			return $options["haslo"] == $options["powtorzHaslo"];
       		},
       		array("haslo"=>$haslo->getValue(),"powtorzHaslo"=>$powtorzHaslo->getValue() )
       	);
       	$powtorzHasloValidator->setMessage("Hasla musze sie zgadzac",Zend_Validate_Callback::INVALID_VALUE );

		$powtorzHasloToShortValidator = new Zend_Validate_StringLength();
       	$powtorzHasloToShortValidator->setMin(6);
       	$powtorzHasloToShortValidator->setMessage("Haslo musi miec co najmniej 6 znakow",Zend_Validate_StringLength::TOO_SHORT );
       	
       	$powtorzHaslo->addValidators(array($powtorzHasloValidator,$powtorzHasloToShortValidator));
       	
       	$dataUrodzeniaValidator = new Zend_Validate_Date();
       	$dataUrodzeniaValidator->setMessage("Data jest niepoprawna",Zend_Validate_Date::INVALID_DATE);
       	$dataUrodzeniaValidator->setMessage("Data powinna byc w formacie YYYY-MM-DD",Zend_Validate_Date::FALSEFORMAT);
       	$dataUrodzenia->addValidator($dataUrodzeniaValidator);

       	$emailValidator = new Zend_Validate_EmailAddress();
       	$emailValidator->setMessage("Email jest niepoprawny", Zend_Validate_EmailAddress::INVALID_FORMAT);
       	$email->addValidator($emailValidator);
       	
    	$form = new Zend_Form("TheForm");
    	$form->clearDecorators();
		$form
			->addDecorator('FormElements')
//			->addDecorator('HtmlTag', array('tag' => 'div'))
			->addDecorator('Form'); 
    	$form->setMethod("get");
    	$form->addElement($login);
    	$form->addElement($haslo);
    	$form->addElement($powtorzHaslo);
    	$form->addElement($dataUrodzenia);
    	$form->addElement($email);
    	$form->addElement($isadmin);
    	$form->addElement($submit);
    	$form->populate($this->_request->getParams());
		$this->view->assign( 'form', $form );
    	
		if ( in_array( "Zapisz", $this->_request->getParams() ) )
		{
			if ( $form->isValid($this->_request->getParams()) )
				$this->_forward("show","index","default",$this->_request->getParams());
		}
    }
	
	public function showAction()
	{
		$this->view->assign( 'tab', $this->_request->getParams() );
	}
}

